// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: gps_path_tracking.proto

#ifndef PROTOBUF_gps_5fpath_5ftracking_2eproto__INCLUDED
#define PROTOBUF_gps_5fpath_5ftracking_2eproto__INCLUDED

#include <string>

#include <google/protobuf/stubs/common.h>

#if GOOGLE_PROTOBUF_VERSION < 3000000
#error This file was generated by a newer version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please update
#error your headers.
#endif
#if 3000000 < GOOGLE_PROTOBUF_MIN_PROTOC_VERSION
#error This file was generated by an older version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please
#error regenerate this file with a newer version of protoc.
#endif

#include <google/protobuf/arena.h>
#include <google/protobuf/arenastring.h>
#include <google/protobuf/generated_message_util.h>
#include <google/protobuf/metadata.h>
#include <google/protobuf/message.h>
#include <google/protobuf/repeated_field.h>
#include <google/protobuf/extension_set.h>
#include <google/protobuf/unknown_field_set.h>
// @@protoc_insertion_point(includes)

// Internal implementation detail -- do not call these.
void protobuf_AddDesc_gps_5fpath_5ftracking_2eproto();
void protobuf_AssignDesc_gps_5fpath_5ftracking_2eproto();
void protobuf_ShutdownFile_gps_5fpath_5ftracking_2eproto();

class GpsInfo;
class GpsPathTrackingInfo;
class GpsPoint;

// ===================================================================

class GpsPoint : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:GpsPoint) */ {
 public:
  GpsPoint();
  virtual ~GpsPoint();

  GpsPoint(const GpsPoint& from);

  inline GpsPoint& operator=(const GpsPoint& from) {
    CopyFrom(from);
    return *this;
  }

  inline const ::google::protobuf::UnknownFieldSet& unknown_fields() const {
    return _internal_metadata_.unknown_fields();
  }

  inline ::google::protobuf::UnknownFieldSet* mutable_unknown_fields() {
    return _internal_metadata_.mutable_unknown_fields();
  }

  static const ::google::protobuf::Descriptor* descriptor();
  static const GpsPoint& default_instance();

  void Swap(GpsPoint* other);

  // implements Message ----------------------------------------------

  inline GpsPoint* New() const { return New(NULL); }

  GpsPoint* New(::google::protobuf::Arena* arena) const;
  void CopyFrom(const ::google::protobuf::Message& from);
  void MergeFrom(const ::google::protobuf::Message& from);
  void CopyFrom(const GpsPoint& from);
  void MergeFrom(const GpsPoint& from);
  void Clear();
  bool IsInitialized() const;

  int ByteSize() const;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input);
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* output) const;
  ::google::protobuf::uint8* SerializeWithCachedSizesToArray(::google::protobuf::uint8* output) const {
    return InternalSerializeWithCachedSizesToArray(false, output);
  }
  int GetCachedSize() const { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const;
  void InternalSwap(GpsPoint* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return _internal_metadata_.arena();
  }
  inline void* MaybeArenaPtr() const {
    return _internal_metadata_.raw_arena_ptr();
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // required double lat = 1;
  bool has_lat() const;
  void clear_lat();
  static const int kLatFieldNumber = 1;
  double lat() const;
  void set_lat(double value);

  // required double lon = 2;
  bool has_lon() const;
  void clear_lon();
  static const int kLonFieldNumber = 2;
  double lon() const;
  void set_lon(double value);

  // @@protoc_insertion_point(class_scope:GpsPoint)
 private:
  inline void set_has_lat();
  inline void clear_has_lat();
  inline void set_has_lon();
  inline void clear_has_lon();

  // helper for ByteSize()
  int RequiredFieldsByteSizeFallback() const;

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::uint32 _has_bits_[1];
  mutable int _cached_size_;
  double lat_;
  double lon_;
  friend void  protobuf_AddDesc_gps_5fpath_5ftracking_2eproto();
  friend void protobuf_AssignDesc_gps_5fpath_5ftracking_2eproto();
  friend void protobuf_ShutdownFile_gps_5fpath_5ftracking_2eproto();

  void InitAsDefaultInstance();
  static GpsPoint* default_instance_;
};
// -------------------------------------------------------------------

class GpsInfo : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:GpsInfo) */ {
 public:
  GpsInfo();
  virtual ~GpsInfo();

  GpsInfo(const GpsInfo& from);

  inline GpsInfo& operator=(const GpsInfo& from) {
    CopyFrom(from);
    return *this;
  }

  inline const ::google::protobuf::UnknownFieldSet& unknown_fields() const {
    return _internal_metadata_.unknown_fields();
  }

  inline ::google::protobuf::UnknownFieldSet* mutable_unknown_fields() {
    return _internal_metadata_.mutable_unknown_fields();
  }

  static const ::google::protobuf::Descriptor* descriptor();
  static const GpsInfo& default_instance();

  void Swap(GpsInfo* other);

  // implements Message ----------------------------------------------

  inline GpsInfo* New() const { return New(NULL); }

  GpsInfo* New(::google::protobuf::Arena* arena) const;
  void CopyFrom(const ::google::protobuf::Message& from);
  void MergeFrom(const ::google::protobuf::Message& from);
  void CopyFrom(const GpsInfo& from);
  void MergeFrom(const GpsInfo& from);
  void Clear();
  bool IsInitialized() const;

  int ByteSize() const;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input);
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* output) const;
  ::google::protobuf::uint8* SerializeWithCachedSizesToArray(::google::protobuf::uint8* output) const {
    return InternalSerializeWithCachedSizesToArray(false, output);
  }
  int GetCachedSize() const { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const;
  void InternalSwap(GpsInfo* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return _internal_metadata_.arena();
  }
  inline void* MaybeArenaPtr() const {
    return _internal_metadata_.raw_arena_ptr();
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // required double lat = 1;
  bool has_lat() const;
  void clear_lat();
  static const int kLatFieldNumber = 1;
  double lat() const;
  void set_lat(double value);

  // required double lon = 2;
  bool has_lon() const;
  void clear_lon();
  static const int kLonFieldNumber = 2;
  double lon() const;
  void set_lon(double value);

  // required double azi = 3;
  bool has_azi() const;
  void clear_azi();
  static const int kAziFieldNumber = 3;
  double azi() const;
  void set_azi(double value);

  // required double speed = 4;
  bool has_speed() const;
  void clear_speed();
  static const int kSpeedFieldNumber = 4;
  double speed() const;
  void set_speed(double value);

  // required uint32 status = 5;
  bool has_status() const;
  void clear_status();
  static const int kStatusFieldNumber = 5;
  ::google::protobuf::uint32 status() const;
  void set_status(::google::protobuf::uint32 value);

  // @@protoc_insertion_point(class_scope:GpsInfo)
 private:
  inline void set_has_lat();
  inline void clear_has_lat();
  inline void set_has_lon();
  inline void clear_has_lon();
  inline void set_has_azi();
  inline void clear_has_azi();
  inline void set_has_speed();
  inline void clear_has_speed();
  inline void set_has_status();
  inline void clear_has_status();

  // helper for ByteSize()
  int RequiredFieldsByteSizeFallback() const;

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::uint32 _has_bits_[1];
  mutable int _cached_size_;
  double lat_;
  double lon_;
  double azi_;
  double speed_;
  ::google::protobuf::uint32 status_;
  friend void  protobuf_AddDesc_gps_5fpath_5ftracking_2eproto();
  friend void protobuf_AssignDesc_gps_5fpath_5ftracking_2eproto();
  friend void protobuf_ShutdownFile_gps_5fpath_5ftracking_2eproto();

  void InitAsDefaultInstance();
  static GpsInfo* default_instance_;
};
// -------------------------------------------------------------------

class GpsPathTrackingInfo : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:GpsPathTrackingInfo) */ {
 public:
  GpsPathTrackingInfo();
  virtual ~GpsPathTrackingInfo();

  GpsPathTrackingInfo(const GpsPathTrackingInfo& from);

  inline GpsPathTrackingInfo& operator=(const GpsPathTrackingInfo& from) {
    CopyFrom(from);
    return *this;
  }

  inline const ::google::protobuf::UnknownFieldSet& unknown_fields() const {
    return _internal_metadata_.unknown_fields();
  }

  inline ::google::protobuf::UnknownFieldSet* mutable_unknown_fields() {
    return _internal_metadata_.mutable_unknown_fields();
  }

  static const ::google::protobuf::Descriptor* descriptor();
  static const GpsPathTrackingInfo& default_instance();

  void Swap(GpsPathTrackingInfo* other);

  // implements Message ----------------------------------------------

  inline GpsPathTrackingInfo* New() const { return New(NULL); }

  GpsPathTrackingInfo* New(::google::protobuf::Arena* arena) const;
  void CopyFrom(const ::google::protobuf::Message& from);
  void MergeFrom(const ::google::protobuf::Message& from);
  void CopyFrom(const GpsPathTrackingInfo& from);
  void MergeFrom(const GpsPathTrackingInfo& from);
  void Clear();
  bool IsInitialized() const;

  int ByteSize() const;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input);
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* output) const;
  ::google::protobuf::uint8* SerializeWithCachedSizesToArray(::google::protobuf::uint8* output) const {
    return InternalSerializeWithCachedSizesToArray(false, output);
  }
  int GetCachedSize() const { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const;
  void InternalSwap(GpsPathTrackingInfo* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return _internal_metadata_.arena();
  }
  inline void* MaybeArenaPtr() const {
    return _internal_metadata_.raw_arena_ptr();
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // repeated .GpsPoint cur_gps_point = 1;
  int cur_gps_point_size() const;
  void clear_cur_gps_point();
  static const int kCurGpsPointFieldNumber = 1;
  const ::GpsPoint& cur_gps_point(int index) const;
  ::GpsPoint* mutable_cur_gps_point(int index);
  ::GpsPoint* add_cur_gps_point();
  ::google::protobuf::RepeatedPtrField< ::GpsPoint >*
      mutable_cur_gps_point();
  const ::google::protobuf::RepeatedPtrField< ::GpsPoint >&
      cur_gps_point() const;

  // repeated .GpsPoint cur_near_gps_point = 2;
  int cur_near_gps_point_size() const;
  void clear_cur_near_gps_point();
  static const int kCurNearGpsPointFieldNumber = 2;
  const ::GpsPoint& cur_near_gps_point(int index) const;
  ::GpsPoint* mutable_cur_near_gps_point(int index);
  ::GpsPoint* add_cur_near_gps_point();
  ::google::protobuf::RepeatedPtrField< ::GpsPoint >*
      mutable_cur_near_gps_point();
  const ::google::protobuf::RepeatedPtrField< ::GpsPoint >&
      cur_near_gps_point() const;

  // repeated .GpsPoint pre_gps_point = 3;
  int pre_gps_point_size() const;
  void clear_pre_gps_point();
  static const int kPreGpsPointFieldNumber = 3;
  const ::GpsPoint& pre_gps_point(int index) const;
  ::GpsPoint* mutable_pre_gps_point(int index);
  ::GpsPoint* add_pre_gps_point();
  ::google::protobuf::RepeatedPtrField< ::GpsPoint >*
      mutable_pre_gps_point();
  const ::google::protobuf::RepeatedPtrField< ::GpsPoint >&
      pre_gps_point() const;

  // optional double pre_gps_point_azi = 4;
  bool has_pre_gps_point_azi() const;
  void clear_pre_gps_point_azi();
  static const int kPreGpsPointAziFieldNumber = 4;
  double pre_gps_point_azi() const;
  void set_pre_gps_point_azi(double value);

  // optional float min_distance = 5;
  bool has_min_distance() const;
  void clear_min_distance();
  static const int kMinDistanceFieldNumber = 5;
  float min_distance() const;
  void set_min_distance(float value);

  // optional bool finished = 6;
  bool has_finished() const;
  void clear_finished();
  static const int kFinishedFieldNumber = 6;
  bool finished() const;
  void set_finished(bool value);

  // optional .GpsInfo gps_info = 7;
  bool has_gps_info() const;
  void clear_gps_info();
  static const int kGpsInfoFieldNumber = 7;
  const ::GpsInfo& gps_info() const;
  ::GpsInfo* mutable_gps_info();
  ::GpsInfo* release_gps_info();
  void set_allocated_gps_info(::GpsInfo* gps_info);

  // @@protoc_insertion_point(class_scope:GpsPathTrackingInfo)
 private:
  inline void set_has_pre_gps_point_azi();
  inline void clear_has_pre_gps_point_azi();
  inline void set_has_min_distance();
  inline void clear_has_min_distance();
  inline void set_has_finished();
  inline void clear_has_finished();
  inline void set_has_gps_info();
  inline void clear_has_gps_info();

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::uint32 _has_bits_[1];
  mutable int _cached_size_;
  ::google::protobuf::RepeatedPtrField< ::GpsPoint > cur_gps_point_;
  ::google::protobuf::RepeatedPtrField< ::GpsPoint > cur_near_gps_point_;
  ::google::protobuf::RepeatedPtrField< ::GpsPoint > pre_gps_point_;
  double pre_gps_point_azi_;
  float min_distance_;
  bool finished_;
  ::GpsInfo* gps_info_;
  friend void  protobuf_AddDesc_gps_5fpath_5ftracking_2eproto();
  friend void protobuf_AssignDesc_gps_5fpath_5ftracking_2eproto();
  friend void protobuf_ShutdownFile_gps_5fpath_5ftracking_2eproto();

  void InitAsDefaultInstance();
  static GpsPathTrackingInfo* default_instance_;
};
// ===================================================================


// ===================================================================

#if !PROTOBUF_INLINE_NOT_IN_HEADERS
// GpsPoint

// required double lat = 1;
inline bool GpsPoint::has_lat() const {
  return (_has_bits_[0] & 0x00000001u) != 0;
}
inline void GpsPoint::set_has_lat() {
  _has_bits_[0] |= 0x00000001u;
}
inline void GpsPoint::clear_has_lat() {
  _has_bits_[0] &= ~0x00000001u;
}
inline void GpsPoint::clear_lat() {
  lat_ = 0;
  clear_has_lat();
}
inline double GpsPoint::lat() const {
  // @@protoc_insertion_point(field_get:GpsPoint.lat)
  return lat_;
}
inline void GpsPoint::set_lat(double value) {
  set_has_lat();
  lat_ = value;
  // @@protoc_insertion_point(field_set:GpsPoint.lat)
}

// required double lon = 2;
inline bool GpsPoint::has_lon() const {
  return (_has_bits_[0] & 0x00000002u) != 0;
}
inline void GpsPoint::set_has_lon() {
  _has_bits_[0] |= 0x00000002u;
}
inline void GpsPoint::clear_has_lon() {
  _has_bits_[0] &= ~0x00000002u;
}
inline void GpsPoint::clear_lon() {
  lon_ = 0;
  clear_has_lon();
}
inline double GpsPoint::lon() const {
  // @@protoc_insertion_point(field_get:GpsPoint.lon)
  return lon_;
}
inline void GpsPoint::set_lon(double value) {
  set_has_lon();
  lon_ = value;
  // @@protoc_insertion_point(field_set:GpsPoint.lon)
}

// -------------------------------------------------------------------

// GpsInfo

// required double lat = 1;
inline bool GpsInfo::has_lat() const {
  return (_has_bits_[0] & 0x00000001u) != 0;
}
inline void GpsInfo::set_has_lat() {
  _has_bits_[0] |= 0x00000001u;
}
inline void GpsInfo::clear_has_lat() {
  _has_bits_[0] &= ~0x00000001u;
}
inline void GpsInfo::clear_lat() {
  lat_ = 0;
  clear_has_lat();
}
inline double GpsInfo::lat() const {
  // @@protoc_insertion_point(field_get:GpsInfo.lat)
  return lat_;
}
inline void GpsInfo::set_lat(double value) {
  set_has_lat();
  lat_ = value;
  // @@protoc_insertion_point(field_set:GpsInfo.lat)
}

// required double lon = 2;
inline bool GpsInfo::has_lon() const {
  return (_has_bits_[0] & 0x00000002u) != 0;
}
inline void GpsInfo::set_has_lon() {
  _has_bits_[0] |= 0x00000002u;
}
inline void GpsInfo::clear_has_lon() {
  _has_bits_[0] &= ~0x00000002u;
}
inline void GpsInfo::clear_lon() {
  lon_ = 0;
  clear_has_lon();
}
inline double GpsInfo::lon() const {
  // @@protoc_insertion_point(field_get:GpsInfo.lon)
  return lon_;
}
inline void GpsInfo::set_lon(double value) {
  set_has_lon();
  lon_ = value;
  // @@protoc_insertion_point(field_set:GpsInfo.lon)
}

// required double azi = 3;
inline bool GpsInfo::has_azi() const {
  return (_has_bits_[0] & 0x00000004u) != 0;
}
inline void GpsInfo::set_has_azi() {
  _has_bits_[0] |= 0x00000004u;
}
inline void GpsInfo::clear_has_azi() {
  _has_bits_[0] &= ~0x00000004u;
}
inline void GpsInfo::clear_azi() {
  azi_ = 0;
  clear_has_azi();
}
inline double GpsInfo::azi() const {
  // @@protoc_insertion_point(field_get:GpsInfo.azi)
  return azi_;
}
inline void GpsInfo::set_azi(double value) {
  set_has_azi();
  azi_ = value;
  // @@protoc_insertion_point(field_set:GpsInfo.azi)
}

// required double speed = 4;
inline bool GpsInfo::has_speed() const {
  return (_has_bits_[0] & 0x00000008u) != 0;
}
inline void GpsInfo::set_has_speed() {
  _has_bits_[0] |= 0x00000008u;
}
inline void GpsInfo::clear_has_speed() {
  _has_bits_[0] &= ~0x00000008u;
}
inline void GpsInfo::clear_speed() {
  speed_ = 0;
  clear_has_speed();
}
inline double GpsInfo::speed() const {
  // @@protoc_insertion_point(field_get:GpsInfo.speed)
  return speed_;
}
inline void GpsInfo::set_speed(double value) {
  set_has_speed();
  speed_ = value;
  // @@protoc_insertion_point(field_set:GpsInfo.speed)
}

// required uint32 status = 5;
inline bool GpsInfo::has_status() const {
  return (_has_bits_[0] & 0x00000010u) != 0;
}
inline void GpsInfo::set_has_status() {
  _has_bits_[0] |= 0x00000010u;
}
inline void GpsInfo::clear_has_status() {
  _has_bits_[0] &= ~0x00000010u;
}
inline void GpsInfo::clear_status() {
  status_ = 0u;
  clear_has_status();
}
inline ::google::protobuf::uint32 GpsInfo::status() const {
  // @@protoc_insertion_point(field_get:GpsInfo.status)
  return status_;
}
inline void GpsInfo::set_status(::google::protobuf::uint32 value) {
  set_has_status();
  status_ = value;
  // @@protoc_insertion_point(field_set:GpsInfo.status)
}

// -------------------------------------------------------------------

// GpsPathTrackingInfo

// repeated .GpsPoint cur_gps_point = 1;
inline int GpsPathTrackingInfo::cur_gps_point_size() const {
  return cur_gps_point_.size();
}
inline void GpsPathTrackingInfo::clear_cur_gps_point() {
  cur_gps_point_.Clear();
}
inline const ::GpsPoint& GpsPathTrackingInfo::cur_gps_point(int index) const {
  // @@protoc_insertion_point(field_get:GpsPathTrackingInfo.cur_gps_point)
  return cur_gps_point_.Get(index);
}
inline ::GpsPoint* GpsPathTrackingInfo::mutable_cur_gps_point(int index) {
  // @@protoc_insertion_point(field_mutable:GpsPathTrackingInfo.cur_gps_point)
  return cur_gps_point_.Mutable(index);
}
inline ::GpsPoint* GpsPathTrackingInfo::add_cur_gps_point() {
  // @@protoc_insertion_point(field_add:GpsPathTrackingInfo.cur_gps_point)
  return cur_gps_point_.Add();
}
inline ::google::protobuf::RepeatedPtrField< ::GpsPoint >*
GpsPathTrackingInfo::mutable_cur_gps_point() {
  // @@protoc_insertion_point(field_mutable_list:GpsPathTrackingInfo.cur_gps_point)
  return &cur_gps_point_;
}
inline const ::google::protobuf::RepeatedPtrField< ::GpsPoint >&
GpsPathTrackingInfo::cur_gps_point() const {
  // @@protoc_insertion_point(field_list:GpsPathTrackingInfo.cur_gps_point)
  return cur_gps_point_;
}

// repeated .GpsPoint cur_near_gps_point = 2;
inline int GpsPathTrackingInfo::cur_near_gps_point_size() const {
  return cur_near_gps_point_.size();
}
inline void GpsPathTrackingInfo::clear_cur_near_gps_point() {
  cur_near_gps_point_.Clear();
}
inline const ::GpsPoint& GpsPathTrackingInfo::cur_near_gps_point(int index) const {
  // @@protoc_insertion_point(field_get:GpsPathTrackingInfo.cur_near_gps_point)
  return cur_near_gps_point_.Get(index);
}
inline ::GpsPoint* GpsPathTrackingInfo::mutable_cur_near_gps_point(int index) {
  // @@protoc_insertion_point(field_mutable:GpsPathTrackingInfo.cur_near_gps_point)
  return cur_near_gps_point_.Mutable(index);
}
inline ::GpsPoint* GpsPathTrackingInfo::add_cur_near_gps_point() {
  // @@protoc_insertion_point(field_add:GpsPathTrackingInfo.cur_near_gps_point)
  return cur_near_gps_point_.Add();
}
inline ::google::protobuf::RepeatedPtrField< ::GpsPoint >*
GpsPathTrackingInfo::mutable_cur_near_gps_point() {
  // @@protoc_insertion_point(field_mutable_list:GpsPathTrackingInfo.cur_near_gps_point)
  return &cur_near_gps_point_;
}
inline const ::google::protobuf::RepeatedPtrField< ::GpsPoint >&
GpsPathTrackingInfo::cur_near_gps_point() const {
  // @@protoc_insertion_point(field_list:GpsPathTrackingInfo.cur_near_gps_point)
  return cur_near_gps_point_;
}

// repeated .GpsPoint pre_gps_point = 3;
inline int GpsPathTrackingInfo::pre_gps_point_size() const {
  return pre_gps_point_.size();
}
inline void GpsPathTrackingInfo::clear_pre_gps_point() {
  pre_gps_point_.Clear();
}
inline const ::GpsPoint& GpsPathTrackingInfo::pre_gps_point(int index) const {
  // @@protoc_insertion_point(field_get:GpsPathTrackingInfo.pre_gps_point)
  return pre_gps_point_.Get(index);
}
inline ::GpsPoint* GpsPathTrackingInfo::mutable_pre_gps_point(int index) {
  // @@protoc_insertion_point(field_mutable:GpsPathTrackingInfo.pre_gps_point)
  return pre_gps_point_.Mutable(index);
}
inline ::GpsPoint* GpsPathTrackingInfo::add_pre_gps_point() {
  // @@protoc_insertion_point(field_add:GpsPathTrackingInfo.pre_gps_point)
  return pre_gps_point_.Add();
}
inline ::google::protobuf::RepeatedPtrField< ::GpsPoint >*
GpsPathTrackingInfo::mutable_pre_gps_point() {
  // @@protoc_insertion_point(field_mutable_list:GpsPathTrackingInfo.pre_gps_point)
  return &pre_gps_point_;
}
inline const ::google::protobuf::RepeatedPtrField< ::GpsPoint >&
GpsPathTrackingInfo::pre_gps_point() const {
  // @@protoc_insertion_point(field_list:GpsPathTrackingInfo.pre_gps_point)
  return pre_gps_point_;
}

// optional double pre_gps_point_azi = 4;
inline bool GpsPathTrackingInfo::has_pre_gps_point_azi() const {
  return (_has_bits_[0] & 0x00000008u) != 0;
}
inline void GpsPathTrackingInfo::set_has_pre_gps_point_azi() {
  _has_bits_[0] |= 0x00000008u;
}
inline void GpsPathTrackingInfo::clear_has_pre_gps_point_azi() {
  _has_bits_[0] &= ~0x00000008u;
}
inline void GpsPathTrackingInfo::clear_pre_gps_point_azi() {
  pre_gps_point_azi_ = 0;
  clear_has_pre_gps_point_azi();
}
inline double GpsPathTrackingInfo::pre_gps_point_azi() const {
  // @@protoc_insertion_point(field_get:GpsPathTrackingInfo.pre_gps_point_azi)
  return pre_gps_point_azi_;
}
inline void GpsPathTrackingInfo::set_pre_gps_point_azi(double value) {
  set_has_pre_gps_point_azi();
  pre_gps_point_azi_ = value;
  // @@protoc_insertion_point(field_set:GpsPathTrackingInfo.pre_gps_point_azi)
}

// optional float min_distance = 5;
inline bool GpsPathTrackingInfo::has_min_distance() const {
  return (_has_bits_[0] & 0x00000010u) != 0;
}
inline void GpsPathTrackingInfo::set_has_min_distance() {
  _has_bits_[0] |= 0x00000010u;
}
inline void GpsPathTrackingInfo::clear_has_min_distance() {
  _has_bits_[0] &= ~0x00000010u;
}
inline void GpsPathTrackingInfo::clear_min_distance() {
  min_distance_ = 0;
  clear_has_min_distance();
}
inline float GpsPathTrackingInfo::min_distance() const {
  // @@protoc_insertion_point(field_get:GpsPathTrackingInfo.min_distance)
  return min_distance_;
}
inline void GpsPathTrackingInfo::set_min_distance(float value) {
  set_has_min_distance();
  min_distance_ = value;
  // @@protoc_insertion_point(field_set:GpsPathTrackingInfo.min_distance)
}

// optional bool finished = 6;
inline bool GpsPathTrackingInfo::has_finished() const {
  return (_has_bits_[0] & 0x00000020u) != 0;
}
inline void GpsPathTrackingInfo::set_has_finished() {
  _has_bits_[0] |= 0x00000020u;
}
inline void GpsPathTrackingInfo::clear_has_finished() {
  _has_bits_[0] &= ~0x00000020u;
}
inline void GpsPathTrackingInfo::clear_finished() {
  finished_ = false;
  clear_has_finished();
}
inline bool GpsPathTrackingInfo::finished() const {
  // @@protoc_insertion_point(field_get:GpsPathTrackingInfo.finished)
  return finished_;
}
inline void GpsPathTrackingInfo::set_finished(bool value) {
  set_has_finished();
  finished_ = value;
  // @@protoc_insertion_point(field_set:GpsPathTrackingInfo.finished)
}

// optional .GpsInfo gps_info = 7;
inline bool GpsPathTrackingInfo::has_gps_info() const {
  return (_has_bits_[0] & 0x00000040u) != 0;
}
inline void GpsPathTrackingInfo::set_has_gps_info() {
  _has_bits_[0] |= 0x00000040u;
}
inline void GpsPathTrackingInfo::clear_has_gps_info() {
  _has_bits_[0] &= ~0x00000040u;
}
inline void GpsPathTrackingInfo::clear_gps_info() {
  if (gps_info_ != NULL) gps_info_->::GpsInfo::Clear();
  clear_has_gps_info();
}
inline const ::GpsInfo& GpsPathTrackingInfo::gps_info() const {
  // @@protoc_insertion_point(field_get:GpsPathTrackingInfo.gps_info)
  return gps_info_ != NULL ? *gps_info_ : *default_instance_->gps_info_;
}
inline ::GpsInfo* GpsPathTrackingInfo::mutable_gps_info() {
  set_has_gps_info();
  if (gps_info_ == NULL) {
    gps_info_ = new ::GpsInfo;
  }
  // @@protoc_insertion_point(field_mutable:GpsPathTrackingInfo.gps_info)
  return gps_info_;
}
inline ::GpsInfo* GpsPathTrackingInfo::release_gps_info() {
  // @@protoc_insertion_point(field_release:GpsPathTrackingInfo.gps_info)
  clear_has_gps_info();
  ::GpsInfo* temp = gps_info_;
  gps_info_ = NULL;
  return temp;
}
inline void GpsPathTrackingInfo::set_allocated_gps_info(::GpsInfo* gps_info) {
  delete gps_info_;
  gps_info_ = gps_info;
  if (gps_info) {
    set_has_gps_info();
  } else {
    clear_has_gps_info();
  }
  // @@protoc_insertion_point(field_set_allocated:GpsPathTrackingInfo.gps_info)
}

#endif  // !PROTOBUF_INLINE_NOT_IN_HEADERS
// -------------------------------------------------------------------

// -------------------------------------------------------------------


// @@protoc_insertion_point(namespace_scope)

// @@protoc_insertion_point(global_scope)

#endif  // PROTOBUF_gps_5fpath_5ftracking_2eproto__INCLUDED
